# Extended WPF Toolkit™

Extended WPF Toolkit™ by [Xceed](https://xceed.com) is the number one collection of WPF controls, components and utilities for creating next generation Windows applications. Use it to build professional looking, modern, and easy to use WPF applications. It has been downloaded more than 1 million times here, on Codeplex, and on [NuGet](http://www.nuget.org/packages/Extended.Wpf.Toolkit/).

This free and open source toolkit is provided under the [Microsoft Public License](https://opensource.org/licenses/MS-PL). A summary can be found on [tl;drLegal](https://tldrlegal.com/license/microsoft-public-license-(ms-pl)).

<a href="../../wiki/Xceed-Toolkit-Plus-for-WPF"><img align="right" src="https://user-images.githubusercontent.com/21266763/27969643-a5977614-6319-11e7-828e-b40fd1f8a283.png" width="233" style="margin:0px 30px" alt="Learn about Xceed Toolkit Plus for WPF here on Github"></a>Xceed offers the [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) for developers that want to support the project, get additional controls and features, get updates and professional support, and work with a version a few releases ahead.

## Latest news

**February 7, 2019** v3.5.0 released with [26 bug fixes and improvements](../../wiki/Improvements-in-v3.5.0). Users of the [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v3.5.0 on September 12, 2017 with [29 bug fixes and improvements](../../wiki/Improvements-in-v3.3.0#Plus350), v3.6.0 on January 15, 2018 with [1 new control and 40 bug fixes and improvements](../../wiki/Improvements-in-v3.3.0#Plus360), v3.7.0 on June 18, 2018 with [27 bug fixes and improvements](../../wiki/Improvements-in-v3.5.0#Plus370) and v3.8.0 on January 30, 2019 with [45 bug fixes and improvements](../../wiki/Improvements-in-v3.5.0#Plus380)

**January 30, 2019** v3.8.0 of the [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) released with [45 bug fixes and improvements](../../wiki/Improvements-in-v3.5.0#Plus380)

**July 11, 2017:** The project's new home is Github. All issues from Codeplex are now located here.

<img src="https://user-images.githubusercontent.com/21266763/27752265-1db3056c-5dae-11e7-8ef4-9728f01494e7.png" width="172"/>

## Controls included

<table>
<tr>
<td><a href="../../wiki/AvalonDock">AvalonDock</a></td>
<td><a href="../../wiki/AutoSelectTextBox">AutoSelectTextBox</a></td>
<td><a href="../../wiki/BusyIndicator">BusyIndicator</a></td>
<td><a href="../../wiki/Calculator">Calculator</a></td>
</tr>
<tr>
<td><a href="../../wiki/CalculatorUpDown">CalculatorUpDown</a></td>
<td><a href="../../wiki/CheckComboBox">CheckComboBox</a></td>
<td><a href="../../wiki/CheckListBox">CheckListBox</a></td>
<td><a href="../../wiki/ChildWindow">ChildWindow</a></td>
</tr>
<tr>
<td><a href="../../wiki/CollectionControl">CollectionControl</a></td>
<td><a href="../../wiki/ButtonSpinner">ButtonSpinner</a></td>
<td><a href="../../wiki/ByteUpDown">ByteUpDown</a></td>
<td><a href="../../wiki/CollectionControlDialog">CollectionControlDialog</a></td>
</tr>
<tr>
<td><a href="../../wiki/ColorCanvas">ColorCanvas</a></td>
<td><a href="../../wiki/ColorPicker">ColorPicker</a></td>
<td><a href="../../wiki/DateTimePicker">DateTimePicker</a></td>
<td><a href="../../wiki/DateTimeUpDown">DateTimeUpDown</a></td>
</tr>
<tr>
<td><a href="../../wiki/DecimalUpDown">DecimalUpDown</a></td>
<td><a href="../../wiki/DoubleUpDown">DoubleUpDown</a></td>
<td><a href="../../wiki/DropDownButton">DropDownButton</a></td>
<td><a href="../../wiki/IconButton">IconButton</a></td>
</tr>
<tr>
<td><a href="../../wiki/IntegerUpDown">IntegerUpDown</a></td>
<td><a href="../../wiki/LongUpDown">LongUpDown</a></td>
<td><a href="../../wiki/Magnifier">Magnifier</a></td>
<td><a href="../../wiki/MaskedTextBox">MaskedTextBox</a></td>
</tr>
<tr>
<td><a href="../../wiki/MessageBox">MessageBox</a></td>
<td><a href="../../wiki/MultiLineTextEditor">MultiLineTextEditor</a></td>
<td><a href="../../wiki/PieChart">PieChart</a></td>
<td><a href="../../wiki/PrimitiveTypeCollectionEditor">PrimitiveTypeCollEditor</a></td>
</tr>
<tr>
<td><a href="../../wiki/PropertyGrid">PropertyGrid</a></td>
<td><a href="../../wiki/RangeSlider">RangeSlider</a></td>
<td><a href="../../wiki/RichTextBox">RichTextBox</a></td>
<td><a href="../../wiki/RichTextBoxFormatBar">RichTextBoxFormatBar</a></td>
</tr>
<tr>
<td><a href="../../wiki/ShortUpDown">ShortUpDown</a></td>
<td><a href="../../wiki/SingleUpDown">SingleUpDown</a></td>
<td><a href="../../wiki/SplitButton">SplitButton</a></td>
<td><a href="../../wiki/SwitchPanel">2 SwitchPanels</a></td>
</tr>
<tr>
<td><a href="../../wiki/TimelinePanel">TimelinePanel</a></td>
<td><a href="../../wiki/TimePicker">TimePicker</a></td>
<td><a href="../../wiki/TimeSpanUpDown">TimeSpanUpDown</a></td>
<td><a href="../../wiki/ValueRangeTextBox">ValueRangeTextBox</a></td>
</tr>
<tr>
<td><a href="../../wiki/WatermarkPasswordBox">WatermarkPasswordBox</a></td>
<td><a href="../../wiki/WatermarkTextBox">WatermarkTextBox</a></td>
<td><a href="../../wiki/WatermarkComboBox">WatermarkComboBox</a></td>
<td><a href="../../wiki/WindowContainer">WindowContainer</a></td>
</tr>
<tr>
<td><a href="../../wiki/WindowControl">WindowControl</a></td>
<td><a href="../../wiki/Wizard">Wizard</a></td>
<td><a href="../../wiki/Zoombox">Zoombox</a></td>
<td><a href="../../wiki/Themes-Usage-Instructions">Windows 8 Theme</a></td>
</tr>
</table>

## Additional controls and features in the Plus Edition

<table>
<tr>
<td><a href="../../wiki/Charts">Charts</a></td>
<td><a href="../../wiki/ChildWindow-Plus">ChildWindow Plus</a></td>
<td><a href="../../wiki/ExtendedTabControl">ExtendedTabControl</a></td>
<td><a href="../../wiki/DataGrid">DataGrid</a></td>
</tr>
<tr>
<td><a href="../../wiki/FilePicker">FilePicker</a></td>
<td><a href="../../wiki/Material-Design-controls">21 Material Design controls</a></td>
<td><a href="../../wiki/MessageBox-Plus">MessageBox Plus</a></td>
<td><a href="../../wiki/MultiCalendar">MultiCalendar</a></td>
</tr>
<tr>
<td><a href="../../wiki/MultiColumnComboBox">MultiColumnComboBox</a></td>
<td><a href="../../wiki/PileFlowPanel">PileFlowPanel</a></td>
<td><a href="../../wiki/PropertyGrid-Plus">PropertyGrid Plus</a></td>
<td><a href="../../wiki/RadialGauge">RadialGauge</a></td>
</tr>
<tr>
<td><a href="../../wiki/Rating">Rating</a></td>
<td><a href="../../wiki/SlideShow">SlideShow</a></td>
<td><a href="../../wiki/StyleableWindow">StyleableWindow</a></td>
<td><a href="../../wiki/SwitchPanel-Plus">12 new SwitchPanels</a></td>
</tr>
<tr>
<td><a href="../../wiki/ToggleSwitch">ToggleSwitch</a></td>
<td><a href="../../wiki/TokenizedTextBox">TokenizedTextBox</a></td>
<td><a href="../../wiki/Ultimate-ListBox">Ultimate ListBox</a></td>
<td><a href="../../wiki/WindowControl-Plus">WindowControl Plus</a></td>
</tr>
<tr>
<td><a href="../../wiki/Themes-Usage-Instructions">Windows 10 theme</a></td>
<td><a href="../../wiki/Xceed-Toolkit-Plus-for-WPF#feature-comparison">2 Metro themes</a></td>
<td><a href="../../wiki/Xceed-Toolkit-Plus-for-WPF#feature-comparison">3 Office themes</a></td>
<td><a href="../../wiki/Xceed-Toolkit-Plus-for-WPF#feature-comparison">2+ releases ahead</a></td>
</tr>
</table>

## Additional controls and features in the Business Suite for WPF

<table>
<tr>
<td><a href="../../wiki/Advanced-DataGrid">Advanced DataGrid</a></td>
<td><a href="../../wiki/Xceed-Toolkit-Plus-for-WPF#feature-comparison">10 new DataGrid editors</a></td>
<td><a href="../../wiki/Xceed-Toolkit-Plus-for-WPF#feature-comparison">3D Views for WPF</a></td>
<td><a href="../../wiki/Xceed-Toolkit-Plus-for-WPF#feature-comparison">More themes</a></td>
<td><a href="../../wiki/Xceed-Toolkit-Plus-for-WPF#feature-comparison">All base WPF controls themed</a></td>
</tr>
</table>

## Release history

* **February 7, 2019 v3.5.0 released with [26 bug fixes and improvements](../../wiki/Improvements-in-v3.5.0).**
* January 30, 2019, released v3.8.0 of the [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) released with [45 bug fixes and improvements](../../wiki/Improvements-in-v3.5.0#Plus380).
* **June 27, 2018 v3.4.0 released with [42 bug fixes and improvements](../../wiki/Improvements-in-v3.4.0).**
* June 18, 2018, released v3.7.0 of the [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) released with [27 bug fixes and improvements](../../wiki/Improvements-in-v3.3.0#Plus370).
* **March 5, 2018, released v3.3.0 with [a major update to the DataGrid and 35 bug fixes and improvements](../../wiki/Improvements-in-v3.3.0).**
* Jan. 15, 2018, released v3.6.0 of the [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) released with [1 new control and 40 bug fixes and improvements](../../wiki/Improvements-in-v3.2.0#Plus360).
* **September 25, 2017, released v3.2.0 with [1 new control and 24 bug fixes and improvements](../../wiki/Improvements-in-v3.2.0).**
* September 12, 2017, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v3.5.0 with [29 bug fixes and improvements](../../wiki/Improvements-in-v3.2.0#Plus350).
* **July 11, 2017, released v3.1.0 with [37 bug fixes and improvements](../../wiki/Improvements-in-v3.1.0).**
* **July 11, 2017, project moved to Github from Codeplex.** Over 440K downloads on Codeplex. 800K on NuGet. 
* June 5, 2017, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v3.4.0 with [52 bug fixes and improvements](../../wiki/Improvements-in-v3.1.0#Plus340).
* March 1, 2017, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v3.3.0 with [45 bug fixes and improvements](../../wiki/Improvements-in-v3.1.0#Plus330).
* **Dec. 13, 2016, released v3.0.0 with [1 new control and 28 bug fixes and improvements](../../wiki/Improvements-in-v3.0.0).**
* Nov. 21, 2016, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v3.2.0 with [2 new controls and 44 bug fixes and improvements](../../wiki/Improvements-in-v3.0.0#Plus320).
* July 13, 2016, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v3.1.0 with [Windows 10 theme and 56 bug fixes and improvements](../../wiki/Improvements-in-v2.9.0#Plus310).
* **June 14, 2016, released v2.9.0 with [32 bug fixes and improvements](../../wiki/Improvements-in-v2.9.0).**
* **May 6, 2016, released v2.8.0 with [23 bug fixes and improvements](../../wiki/Improvements-in-v2.8.0).**
* **April 6, 2016, released v2.7.0 with [31 bug fixes and improvements](../../wiki/Improvements-in-v2.7.0).**
* April 5, 2016, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v3.0.0 with [2 new controls and 41 bug fixes and improvements](../../wiki/Improvements-in-v2.7.0#Plus300). 
* Feb. 10, 2016, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v2.9.0 with [44 bug fixes and improvements](../../wiki/Improvements-in-v2.7.0#Plus290). 
* **Jan. 8, 2016, released v2.6.0 with [15 bug fixes and improvements](../../wiki/Improvements-in-v2.6.0).**
* Sept. 14, 2015, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v2.8.0 with [15 new controls and 41 bug fixes and improvements](../../wiki/Improvements-in-v2.6.0#Plus280). 
* **July 3, 2015, released v2.5.0 with [1 new control and 45 bug fixes and improvements](../../wiki/Improvements-in-v2.5.0#Community250).**
* **Feb. 13, 2015, released v2.4.0 with [37 bug fixes and improvements](../../wiki/Improvements-in-v2.4.0#Community240).**
* **Oct. 7, 2014, released v2.3.0 with [25 bug fixes and improvements](../../wiki/Improvements-in-v2.3.0#Community230).**
* Sept. 29, 2014, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v2.4.0 with [1 new control and 42 bug fixes and improvements](../../wiki/Improvements-in-v2.3.0#Plus240).
* **June 17, 2014, released v2.2.1 with [5 bug fixes](../../wiki/Improvements-in-v2.2.0#Community221).**
* June 17, 2014, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v2.3.1 with [6 bug fixes](../../wiki/Improvements-in-v2.2.0#Plus231).
* **June 2, 2014, released v2.2.0, with [2 new controls and 15 bug fixes and improvements](../../wiki/Improvements-in-v2.2.0#Community220).**
* May 12, 2014, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v2.3.0 with [1 new control and 30 bug fixes and improvements](../../wiki/Improvements-in-v2.2.0#Plus230).
* **Feb 20, 2014, released v2.1.0 with [70 bug fixes and improvements](../../wiki/Improvements-in-v2.1.0#Community210).**
* Feb. 12, 2014, released [Plus Edition](../../wiki/Xceed-Toolkit-Plus-for-WPF) v2.2.0 with [4 new controls and 18 bug fixes and improvements](../../wiki/Improvements-in-v2.2.0#Plus220). 

## Action items

* Enjoy WPF!
* Buy [Xceed Toolkit Plus for WPF](https://xceed.com/xceed-toolkit-plus-for-wpf/)
* Follow [@xceed](http://twitter.com/xceed) on Twitter for WPF and Toolkit news
* Add bugs or feature requests with the Issues tab
<br>
<br>
<a href="https://xceed.com/"><img src="https://user-images.githubusercontent.com/21266763/27974888-eecc663c-632d-11e7-8f3b-abf39b8fa913.png" width="278"/></a>
